/// <reference types="react" />
import { Field } from '../../field';
import { IBaseCheckboxProps, IBaseCheckboxState, IBaseCheckboxInputProps } from './checkbox.interface';
import { IBasicEvent } from '../../../react-definitions.interface';
export declare class BaseCheckbox<TProps extends IBaseCheckboxProps = IBaseCheckboxProps, TState extends IBaseCheckboxState = IBaseCheckboxState> extends Field<TProps, TState> {
    private inputId;
    /**
     * @stable [17.12.2018]
     * @param {JSX.Element} body
     * @returns {JSX.Element}
     */
    protected getWrapperElement(body: JSX.Element): JSX.Element;
    /**
     * @stable [31.08.2018]
     * @returns {IBaseCheckboxInputProps}
     */
    protected getInputElementProps(): IBaseCheckboxInputProps;
    /**
     * @stable [31.08.2018]
     * @param {IBasicEvent} event
     */
    protected onClick(event: IBasicEvent): void;
    /**
     * @stable [31.08.2018]
     * @returns {JSX.Element}
     */
    protected getLabelElement(): JSX.Element;
}
