/// <reference types="react" />
import { BaseContainer } from '../base';
import { IFormContainer, IFormContainerProps } from './form.interface';
export declare class FormContainer extends BaseContainer<IFormContainerProps> implements IFormContainer {
    constructor(props: IFormContainerProps);
    render(): JSX.Element;
    /**
     * @stable [17.10.2018]
     */
    submit(): void;
    /**
     * @stable [17.02.2019]
     * @param {IFieldChangeEntity} payload
     */
    private onChange;
    /**
     * @stable [17.02.2019]
     * @param {boolean} valid
     */
    private onValid;
    /**
     * @stable [24.02.2019]
     */
    private onReset;
    private onSubmit;
    /**
     * @stable - 11.04.2018
     * @param {IApiEntity} apiEntity
     * @returns {boolean}
     */
    private onBeforeSubmit;
    /**
     * @stable [04.08.2018]
     * @param {string} dictionary
     * @param {IApiEntity} apiEntity
     */
    private onEmptyDictionary;
    private onLoadDictionary;
    private readonly form;
}
