"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var R = require("ramda");
var base_1 = require("../base");
var form_1 = require("../form");
var form_interface_1 = require("./form.interface");
var FormContainer = /** @class */ (function (_super) {
    __extends(FormContainer, _super);
    function FormContainer(props) {
        var _this = _super.call(this, props) || this;
        _this.onChange = _this.onChange.bind(_this);
        _this.onValid = _this.onValid.bind(_this);
        _this.onSubmit = _this.onSubmit.bind(_this);
        _this.onReset = _this.onReset.bind(_this);
        _this.onBeforeSubmit = _this.onBeforeSubmit.bind(_this);
        _this.onEmptyDictionary = _this.onEmptyDictionary.bind(_this);
        _this.onLoadDictionary = _this.onLoadDictionary.bind(_this);
        return _this;
    }
    FormContainer.prototype.render = function () {
        var props = this.props;
        return (React.createElement(form_1.Form, __assign({ ref: 'form', form: props.form, entity: props.entity, originalEntity: props.originalEntity, onChange: this.onChange, onSubmit: this.onSubmit, onBeforeSubmit: this.onBeforeSubmit, onReset: this.onReset, onValid: this.onValid, onEmptyDictionary: this.onEmptyDictionary, onLoadDictionary: this.onLoadDictionary }, props.formConfiguration), props.children));
    };
    /**
     * @stable [17.10.2018]
     */
    FormContainer.prototype.submit = function () {
        this.form.submit(this.form.apiEntity);
    };
    /**
     * @stable [17.02.2019]
     * @param {IFieldChangeEntity} payload
     */
    FormContainer.prototype.onChange = function (payload) {
        if (payload.name) {
            this.dispatchFrameworkAction(form_interface_1.FORM_CHANGE_ACTION_TYPE, payload);
        }
    };
    /**
     * @stable [17.02.2019]
     * @param {boolean} valid
     */
    FormContainer.prototype.onValid = function (valid) {
        this.dispatch(form_interface_1.FORM_VALID_ACTION_TYPE, { valid: valid });
    };
    /**
     * @stable [24.02.2019]
     */
    FormContainer.prototype.onReset = function () {
        this.dispatchFrameworkAction(form_interface_1.FORM_RESET_ACTION_TYPE);
    };
    FormContainer.prototype.onSubmit = function (apiEntity) {
        this.dispatch(form_interface_1.FORM_SUBMIT_ACTION_TYPE, apiEntity);
    };
    /**
     * @stable - 11.04.2018
     * @param {IApiEntity} apiEntity
     * @returns {boolean}
     */
    FormContainer.prototype.onBeforeSubmit = function (apiEntity) {
        var props = this.props;
        return props.onBeforeSubmit && props.onBeforeSubmit(apiEntity);
    };
    /**
     * @stable [04.08.2018]
     * @param {string} dictionary
     * @param {IApiEntity} apiEntity
     */
    FormContainer.prototype.onEmptyDictionary = function (dictionary, apiEntity) {
        this.dispatchLoadDictionary(dictionary, apiEntity);
    };
    FormContainer.prototype.onLoadDictionary = function (items) {
        var noAvailableItemsToSelect = this.settings.messages.noAvailableItemsToSelectMessage;
        if (noAvailableItemsToSelect && R.isEmpty(items)) {
            this.dispatchNotification(noAvailableItemsToSelect);
        }
    };
    Object.defineProperty(FormContainer.prototype, "form", {
        get: function () {
            return this.refs.form;
        },
        enumerable: true,
        configurable: true
    });
    return FormContainer;
}(base_1.BaseContainer));
exports.FormContainer = FormContainer;
//# sourceMappingURL=form.container.js.map