import { IEntity } from '../../definitions.interface';
import { IApiEntity } from '../../entities-definitions.interface';
import { IFieldConfiguration, ITabConfiguration, ITabPanelConfiguration } from '../../configurations-definitions.interface';
import { IFormProps } from './form.interface';
/**
 * TODO api support buildApiEntity
 * @param {IEntity} changes
 * @param {IEntity} entity
 * @param {IEntity} originalEntity
 * @param {string} operationId
 * @returns {IApiEntity}
 */
export declare const buildApiEntity: (changes: IEntity, entity?: IEntity, originalEntity?: IEntity, operationId?: string) => IApiEntity<IEntity>;
/**
 * @stable [29.05.2018]
 * @param {IFormProps} formProps
 * @param {IFieldConfiguration} fieldProps
 * @returns {boolean}
 */
export declare const isFormFieldReadOnly: (formProps: IFormProps, fieldProps: IFieldConfiguration) => boolean;
/**
 * @stable [29.05.2018]
 * @param {IFormProps} formProps
 * @param {IFieldConfiguration} fieldProps
 * @returns {boolean}
 */
export declare const isFormFieldDisabled: (formProps: IFormProps, fieldProps: IFieldConfiguration) => boolean;
/**
 * @stable [16.11.2018]
 * @param {IFormProps} formProps
 * @param {IFieldConfiguration} fieldProps
 * @returns {boolean}
 */
export declare const isFormFieldChangeable: (formProps: IFormProps, fieldProps: IFieldConfiguration) => boolean;
/**
 * @stable [29.05.2018]
 * @param {IFormProps} formProps
 * @returns {boolean}
 */
export declare const isFormDisabled: (formProps: IFormProps) => boolean;
/**
 * @stable [16.11.2018]
 * @param {IFormProps} formProps
 * @returns {boolean}
 */
export declare const isFormChangeable: (formProps: IFormProps) => boolean;
/**
 * @stable [03.08.2018]
 * @param {IFormProps} formProps
 * @returns {boolean}
 */
export declare const isFormValid: (formProps: IFormProps) => boolean;
/**
 * @stable [29.05.2018]
 * @param {IFormProps} formProps
 * @returns {boolean}
 */
export declare const isFormEditable: (formProps: IFormProps) => boolean;
/**
 * @stable [29.05.2018]
 * @param {IFormProps} formProps
 * @returns {boolean}
 */
export declare const isFormDirty: (formProps: IFormProps) => boolean;
/**
 * @stable [03.08.2018]
 * @param {IFormProps} formProps
 * @returns {boolean}
 */
export declare const isFormSubmittable: (formProps: IFormProps) => boolean;
/**
 * @stable [15.02.2019]
 * @param {IFormProps} formProps
 * @returns {boolean}
 */
export declare const isFormResettable: (formProps: IFormProps) => boolean;
/**
 * @stable [29.05.2018]
 * @param {IFormProps} formProps
 * @returns {boolean}
 */
export declare const isFormNewEntity: (formProps: IFormProps) => boolean;
/**
 * @stable [30.08.2018]
 * @param {IFormProps} formProps
 * @param {ITabConfiguration} tab
 * @returns {boolean}
 */
export declare const isFormTabActive: (formProps: IFormProps, tab: ITabConfiguration) => boolean;
/**
 * @stable [30.08.2018]
 * @param {IFormProps} formProps
 * @param {ITabPanelConfiguration} tabPanelConfiguration
 * @returns {number}
 */
export declare const getFormTabActiveValue: (formProps: IFormProps, tabPanelConfiguration: ITabPanelConfiguration) => number;
