/// <reference types="react" />
/// <reference types="googlemaps" />
import { BaseComponent } from '../../base';
import { IGoogleMapsMarkerConfigEntity, IGoogleMapsProps } from './google-maps.interface';
import { IGoogleMaps } from './google-maps.interface';
export declare class GoogleMaps extends BaseComponent<IGoogleMapsProps> implements IGoogleMaps {
    private map;
    private googleMapsScriptTask;
    private delayedTask;
    private clickEventListener;
    private dbClickEventListener;
    private x;
    private y;
    private lat;
    private lng;
    private markers;
    private markersDragListeners;
    /**
     * @stable [31.07.2018]
     * @param {IGoogleMapsProps} props
     */
    constructor(props: IGoogleMapsProps);
    /**
     * @stable [31.07.2018]
     */
    componentDidMount(): void;
    /**
     * @stable [31.07.2018]
     */
    componentWillUnmount(): void;
    /**
     * @stable [31.07.2018]
     * @returns {JSX.Element}
     */
    render(): JSX.Element;
    /**
     * @stable [31.07.2018]
     * @param {google.maps.MarkerOptions} cfg
     * @param {string} name
     * @returns {google.maps.Marker}
     */
    addMarker(cfg?: google.maps.MarkerOptions, name?: string): google.maps.Marker;
    /**
     * @stable [23.02.2019]
     * @param {IGoogleMapsMarkerConfigEntity} cfg
     */
    setMarkerState(cfg: IGoogleMapsMarkerConfigEntity): void;
    /**
     * @stable [31.07.2018]
     * @param {string} markerId
     * @param {google.maps.Marker} marker
     */
    private onMarkerDragEnd;
    /**
     * @stable [31.07.2018]
     * @param {IMenuItemEntity} item
     */
    private onMenuSelect;
    /**
     * @stable [31.07.2018]
     * @param {{pixel: google.maps.Point; latLng: google.maps.LatLng}} event
     */
    private onMapClick;
    /**
     * @stable [31.07.2018]
     */
    private cancelGoogleMapsScriptTaskIfPending;
    /**
     * @stable [31.07.2018]
     */
    private cancelTaskIfPending;
    /**
     * @stable [31.07.2018]
     * @param {{x: number; y: number; lat: number; lng: number}} nextState
     */
    private openMenu;
    /**
     * @stable [31.07.2018]
     */
    private initGoogleMapsObjects;
    /**
     * @stable [31.07.2018]
     * @returns {IMenu}
     */
    private readonly menu;
    /**
     * @stable [26.10.2018]
     * @returns {boolean}
     */
    private readonly hasOptions;
}
