import * as React from 'react';
import { BaseComponent } from '../../base';
import { IBaseGridColumnProps } from './base-grid-column.interface';
export declare class BaseGridColumn<TProps extends IBaseGridColumnProps> extends BaseComponent<TProps> {
    /**
     * @stable [10.09.2018]
     * @param {TProps} style
     * @returns {React.CSSProperties}
     */
    protected getStyle(style?: TProps): React.CSSProperties;
    /**
     * @stable [15.09.2018]
     * @param {string} classNames
     * @returns {string}
     */
    protected getClassName(...classNames: string[]): string;
    /**
     * @stable [10.09.2018]
     * @param {string} classNames
     * @returns {JSX.Element}
     */
    protected getColumnContentElement(...classNames: string[]): JSX.Element;
}
