import { GridColumnConfigurationT, IGridColumnConfiguration } from '../../configurations-definitions.interface';
import { IEntity } from '../../definitions.interface';
import { IGridState, ITimeGridBuilderConfigEntity } from './grid.interface';
import { SortDirectionEnum } from '../../entities-definitions.interface';
import { IGridProps } from '../../props-definitions.interface';
/**
 * @stable [10.09.2018]
 */
export declare const DEFAULT_BUILDER_CONFIG: ITimeGridBuilderConfigEntity;
/**
 * @stable [04.10.2018]
 * @param {GridColumnConfigurationT} defaultConfig
 * @param {string} extraClassName
 * @returns {GridColumnConfigurationT}
 */
export declare const buildTimeGridInfoColumn: (defaultConfig: GridColumnConfigurationT, extraClassName?: string) => GridColumnConfigurationT;
/**
 * @stable [10.09.2018]
 * @param {GridColumnConfigurationT} defaultConfig
 * @param {ITimeGridBuilderConfigEntity} builderConfig
 * @returns {GridColumnConfigurationT[]}
 */
export declare const buildTimeGridColumns: (defaultConfig?: GridColumnConfigurationT, builderConfig?: ITimeGridBuilderConfigEntity) => GridColumnConfigurationT[];
/**
 * @stable [12.02.2019]
 * @param {IGridColumnConfiguration} column
 * @param {IGridProps} props
 * @returns {SortDirectionEnum}
 */
export declare const getGridColumnSortDirection: (column: IGridColumnConfiguration, props: IGridProps) => SortDirectionEnum;
export declare const filterAndSortGridOriginalDataSource: (source: IEntity[], columns: IGridColumnConfiguration[], props: IGridProps, state: IGridState) => IEntity[];
