"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var util_1 = require("../../../util");
var universal_layout_view_builder_1 = require("./universal-layout-view.builder");
var VueLayoutViewBuilder = /** @class */ (function (_super) {
    __extends(VueLayoutViewBuilder, _super);
    function VueLayoutViewBuilder() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * @stable [22.10.2018]
     * @param {IKeyValue} _
     * @param {VueLayoutBuilderChildrenT[]} children
     * @param {IVueLayoutBuilderConfiguration} layoutConfig
     * @returns {string}
     */
    VueLayoutViewBuilder.prototype.buildRowView = function (_, children, layoutConfig) {
        return ("<div class='rac-flex rac-flex-row " + this.toFactorClassName(layoutConfig) + "'>\n        " + util_1.join(children, '') + "\n      </div>");
    };
    /**
     * @stable [22.10.2018]
     * @param {IKeyValue} _
     * @param {VueLayoutBuilderChildrenT[]} children
     * @param {IVueLayoutBuilderConfiguration} layoutConfig
     * @returns {string}
     */
    VueLayoutViewBuilder.prototype.buildColumnView = function (_, children, layoutConfig) {
        return ("<div class='rac-flex rac-flex-column " + this.toFactorClassName(layoutConfig) + "'>\n        " + util_1.join(children, '') + "\n      </div>");
    };
    /**
     * @stable [22.10.2018]
     * @param {IKeyValue} _
     * @returns {string}
     */
    VueLayoutViewBuilder.prototype.buildSeparatorView = function (_) {
        return '<div class="rac-flex-separator"/>';
    };
    return VueLayoutViewBuilder;
}(universal_layout_view_builder_1.UniversalLayoutViewBuilder));
exports.VueLayoutViewBuilder = VueLayoutViewBuilder;
//# sourceMappingURL=vue-layout-view.builder.js.map