"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var tab_bar_1 = require("@material/tab-bar");
var util_1 = require("../../../util");
var material_plugin_1 = require("./material.plugin");
var TabPanelMaterialPlugin = /** @class */ (function (_super) {
    __extends(TabPanelMaterialPlugin, _super);
    /**
     * @stable [30.05.2018]
     * @param {TabPanel} tabPanel
     */
    function TabPanelMaterialPlugin(tabPanel) {
        var _this = _super.call(this, tabPanel, tab_bar_1.MDCTabBar) || this;
        tabPanel.onBackward = util_1.sequence(tabPanel.onBackward, _this.onBackward, _this);
        tabPanel.onForward = util_1.sequence(tabPanel.onForward, _this.onForward, _this);
        return _this;
    }
    /**
     * @stable [15.08.2018]
     */
    TabPanelMaterialPlugin.prototype.onBackward = function () {
        this.adapter.scrollTo(this.adapter.getScrollPosition() - this.offset);
    };
    /**
     * @stable [15.08.2018]
     */
    TabPanelMaterialPlugin.prototype.onForward = function () {
        this.adapter.scrollTo(this.adapter.getScrollPosition() + this.offset);
    };
    Object.defineProperty(TabPanelMaterialPlugin.prototype, "offset", {
        /**
         * @stable [15.08.2018]
         * @returns {number}
         */
        get: function () {
            return this.adapter.getOffsetWidth() / TabPanelMaterialPlugin.OFFSET_FACTOR;
        },
        enumerable: true,
        configurable: true
    });
    TabPanelMaterialPlugin.OFFSET_FACTOR = 2;
    return TabPanelMaterialPlugin;
}(material_plugin_1.MaterialPlugin));
exports.TabPanelMaterialPlugin = TabPanelMaterialPlugin;
//# sourceMappingURL=tabpanel.plugin.js.map