"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var redux_effects_promise_1 = require("redux-effects-promise");
var react_native_router_flux_1 = require("react-native-router-flux");
var R = require("ramda");
var ts_smart_logger_1 = require("ts-smart-logger");
var util_1 = require("../util");
var di_1 = require("../di");
var router_interface_1 = require("./router.interface");
var RnRouterEffects = /** @class */ (function () {
    function RnRouterEffects() {
    }
    RnRouterEffects_1 = RnRouterEffects;
    /* @stable - 15.04.2018 */
    RnRouterEffects.prototype.$onNavigate = function (action) {
        var path = this.toPath(action).path;
        var routerCallback = react_native_router_flux_1.Actions[path];
        if (R.isNil(routerCallback)) {
            RnRouterEffects_1.logger.warn("[$RnRouterEffects][$onNavigate] Router callback is not defined. Path: " + path);
        }
        else {
            RnRouterEffects_1.logger.debug("[$RnRouterEffects][$onNavigate] Path: " + path);
            routerCallback.call(react_native_router_flux_1.Actions);
        }
    };
    /* @stable - 15.04.2018 */
    RnRouterEffects.prototype.$onBack = function () {
        RnRouterEffects_1.logger.debug('[$RnRouterEffects][$onBack]');
        react_native_router_flux_1.Actions.pop();
    };
    RnRouterEffects.prototype.toPath = function (action) {
        var payloadAsString = action.data;
        if (util_1.isString(payloadAsString)) {
            return { path: payloadAsString };
        }
        return action.data;
    };
    var RnRouterEffects_1;
    RnRouterEffects.logger = ts_smart_logger_1.LoggerFactory.makeLogger('RnRouterEffects');
    __decorate([
        redux_effects_promise_1.EffectsService.effects(router_interface_1.ROUTER_NAVIGATE_ACTION_TYPE),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Object]),
        __metadata("design:returntype", void 0)
    ], RnRouterEffects.prototype, "$onNavigate", null);
    __decorate([
        redux_effects_promise_1.EffectsService.effects(router_interface_1.ROUTER_BACK_ACTION_TYPE),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", []),
        __metadata("design:returntype", void 0)
    ], RnRouterEffects.prototype, "$onBack", null);
    RnRouterEffects = RnRouterEffects_1 = __decorate([
        di_1.provideInSingleton(RnRouterEffects_1)
    ], RnRouterEffects);
    return RnRouterEffects;
}());
exports.RnRouterEffects = RnRouterEffects;
//# sourceMappingURL=rn-router.effects.js.map