"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var inversify_1 = require("inversify");
var util_1 = require("../util");
var di_1 = require("../di");
var BaseTransport = /** @class */ (function () {
    function BaseTransport() {
    }
    /**
     * @stable [11.09.2018]
     * @param {ITransportRequestPayloadDataEntity} params
     */
    BaseTransport.prototype.downloadAnchoredFile = function (params) {
        var requestParams = this.transport.makeRequestPayloadData(params);
        util_1.downloadAnchoredFile(util_1.join([this.settings.downloadUrl, util_1.buildUrl(requestParams)]));
    };
    /**
     * @stable - 12.04.2018
     * @param {IEditableApiEntity<TEntity extends IEntity>} entity
     * @returns {Promise<TEntity extends IEntity>}
     */
    BaseTransport.prototype.doSaveEntity = function (entity) {
        var apiEntity = entity.apiEntity;
        return this.transport.request({
            params: __assign({}, apiEntity.changes, util_1.defValuesFilter(entity.extraParams), util_1.defValuesFilter({ id: apiEntity.id })),
            name: apiEntity.isNew ? entity.addApi : entity.editApi,
            operation: apiEntity.operation,
        });
    };
    __decorate([
        di_1.lazyInject(di_1.DI_TYPES.Transport),
        __metadata("design:type", Object)
    ], BaseTransport.prototype, "transport", void 0);
    __decorate([
        di_1.lazyInject(di_1.DI_TYPES.Settings),
        __metadata("design:type", Object)
    ], BaseTransport.prototype, "settings", void 0);
    BaseTransport = __decorate([
        inversify_1.injectable()
    ], BaseTransport);
    return BaseTransport;
}());
exports.BaseTransport = BaseTransport;
//# sourceMappingURL=base.transport.js.map