import { IKeyValue } from '../definitions.interface';
import { ITransport, ITransportRequestEntity } from './transport.interface';
export declare class Transport implements ITransport {
    private static readonly logger;
    private store;
    private transportFactory;
    private readonly requestPayloadFactory;
    /**
     * @stable [02.02.2019]
     * @param {ITransportRequestEntity} requestEntity
     * @returns {IKeyValue}
     */
    makeRequestPayloadData(requestEntity: ITransportRequestEntity): IKeyValue;
    /**
     * @stable [01.02.2019]
     * @param {ITransportRequestEntity} req
     * @returns {Promise<TResponse>}
     */
    request<TResponse>(req: ITransportRequestEntity): Promise<TResponse>;
    /**
     * @stable [07.02.2019]
     * @param {ITransportRequestEntity} req
     */
    cancelRequest(req: ITransportRequestEntity): void;
    /**
     * @stable [17.08.2018]
     * @param {ITransportRequestEntity} req
     */
    private onRequestCancel;
    /**
     * @stable [01.02.2019]
     * @param {ITransportRequestEntity} req
     * @param {ITransportResponseEntity} responseEntity
     */
    private onRequestError;
    /**
     * @stable [01.02.2019]
     * @param {ITransportRequestEntity} req
     * @param {ITransportResponseEntity} responseEntity
     */
    private onRequestDone;
    /**
     * @stable [01.02.2019]
     * @param {ITransportRequestEntity} req
     * @returns {ITransportRequestMetaEntity}
     */
    private toRequestMetaEntity;
    /**
     * @stable [07.02.2019]
     * @param {ITransportRequestEntity} req
     * @returns {string}
     */
    private toOperationId;
    /**
     * @stable [07.02.2019]
     * @param {ITransportRequestEntity} req
     * @returns {ITransportFactory}
     */
    private getTransportFactory;
}
